// $Id: chatter.java,v 1.3 2013-03-19 04:10:48-07 - - $
import static java.lang.System.*;

class chatter {
  static class options {
    final String progname = get_jarname();
    boolean client_is_gui;
    boolean is_server;
    String server_hostname;
    int server_portnumber;
    String username;

    options(String[] args) {
      int itor = 0;
      for (; (itor < args.length) && (args[itor].contains("-")); ++itor)
        if (args[itor].equals("-g")) {
          client_is_gui = true;
          continue;
        }
      try {
        if (args[itor].contains(":")) { // client (has host and port)
          is_server = false;
          String client_info[] = args[itor].split(":");
          server_hostname = client_info[0];
          server_portnumber = Integer.parseInt(client_info[1]);
          username = args[++itor];
        } else { // server (port only specified)
          is_server = true;
          server_hostname = "localhost";
          server_portnumber = Integer.parseInt(args[itor]);
        }
      } catch (Exception ex) {
        quit("Usage: chatter [-g] [hostname:]port username\n");
      }
    }
        
    static String get_jarname() {
      String jarpath = getProperty("java.class.path");
      int lastslash = jarpath.lastIndexOf('/');
      if (lastslash < 0)
        return jarpath;
      return jarpath.substring(lastslash + 1);
    }    
  }
  
  public static void quit (String format, Object... params) {
    err.printf (format, params);
    exit (1);
  }

  public static void main(String[] args) {
    options opts = new options(args);
    if (opts.is_server) 
      new server(opts);
    else if (opts.client_is_gui)
      new gui(opts);
    else
      new client(opts);
  }
}
