import static java.lang.System.out;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.Scanner;
import java.awt.event.*;

// $Id: client.java,v 1.2 2013-03-18 02:40:33-07 - - $

class client {
  static chatter.options opts;
  static Socket socket;

  static String ident(chatter.options opts) {
    return String.format("%s: %s %d", opts.progname, 
        opts.server_hostname, opts.server_portnumber);
  }

  static class textInput implements ActionListener {
    public void actionPerformed(ActionEvent event) {
      PrintWriter client_out;
      try {
        if (socket.isClosed() || socket.isOutputShutdown()
            || socket.isInputShutdown())
          throw new IOException();
        client_out = new PrintWriter(socket.getOutputStream());
        client_out.printf("%s: %s%n", opts.username, 
            gui.textfield.getText());
        client_out.flush();
        gui.textfield.setText("");
      } catch (IOException exn) {
        chatter.quit("%s : %s%n", ident(), exn);
      }
    }
  }

  client(chatter.options _opts) {
    opts = _opts;
    try {
      socket = new Socket(opts.server_hostname, opts.server_portnumber);
      if (!opts.client_is_gui)
        out.printf("%s: socket OK%n", ident(opts));
      else {
        gui.frame.setTitle("chatter: " + ident());
        gui.textarea.append(ident(opts) + ": socket OK\n");
      }
      Thread reading = new Thread(new receiver());
      reading.start();
      if (opts.client_is_gui)
        gui.textfield.addActionListener(new textInput());
      else {
        Thread writing = new Thread(new sender());
        writing.start();
      }
    } catch (IOException exn) {
      chatter.quit("%s : %s%n", ident(), exn);
    } catch (IllegalArgumentException exn) {
      chatter.quit("%s : %s%n", ident(), exn);
    }
  }

  static class receiver implements Runnable {
    public void run() {
      try {
        Scanner input = new Scanner(socket.getInputStream());

        while (!socket.isClosed() && !socket.isInputShutdown())
          while (input.hasNextLine())
            if (!opts.client_is_gui)
              System.out.print(input.nextLine() + '\n');
            else
              gui.textarea.append(input.nextLine() + '\n');

      } catch (IOException exn) {
        chatter.quit("%s : %s%n", ident(), exn);
      }
    }
  }
  
  static String ident() {
    return String.format("%s : %s:%d", opts.progname, 
            opts.server_hostname,
            opts.server_portnumber);
  }

  static class sender implements Runnable {
    public void run() {
      try {
        PrintWriter client_out = 
            new PrintWriter(socket.getOutputStream());
        Scanner input = new Scanner(System.in);
        while (input.hasNextLine()) {
          String line = input.nextLine();
          if (socket.isOutputShutdown() || line == null)
            break;
          client_out.printf("%s: %s%n", opts.username, line);
          client_out.flush();
        }
        client_out.close();
      } catch (IOException exn) {
        chatter.quit("%s : %s%n", ident(), exn);
      }
    }
  }

}
