// $Id: server.java,v 1.3 2013-03-19 04:05:00-07 - - $

import java.io.*;
import java.net.*;
import java.util.*;
import static java.lang.System.*;
import java.util.concurrent.*;

class server {
  static ServerSocket socket;
  static BlockingQueue<String> buffer;
  static ConcurrentHashMap<Socket, Thread> clients;
//  static ConcurrentHashMap<String, Thread> users;
  static chatter.options opts;

  server(chatter.options _opts) {
    opts = _opts;
    buffer = new LinkedBlockingQueue<String>();
    clients = new ConcurrentHashMap<Socket, Thread>();
    try {
      socket = new ServerSocket(opts.server_portnumber);

      // Thread queue_thread = new Thread(new queue_mgr());
      // queue_thread.start();
      Thread sender_thread = new Thread(new sender());
      sender_thread.start();
      for (;;) {
        Socket client = socket.accept();
        System.out.println("Starting thread for client: "
            + client.getInetAddress().getHostAddress());
        Thread rcvr_thread = new Thread(new receiver(client));
        rcvr_thread.start();
        clients.put(client, rcvr_thread);
        //users.put(, )
      }
    } catch (IOException exn) {
      chatter.quit("Connection problem: %s%n", exn);
    }
  }

  static String get_jarname() {
    String jarpath = getProperty("java.class.path");
    int lastslash = jarpath.lastIndexOf('/');
    if (lastslash < 0)
      return jarpath;
    return jarpath.substring(lastslash + 1);
  }

  static String ident() {
    return String.format("%s: port %d", opts.progname,
        opts.server_portnumber);
  }

  static class receiver implements Runnable {
    Socket client;

    receiver(Socket _client) {
      client = _client;
    }

    public void run() {
      try {
        Scanner client_in = new Scanner(client.getInputStream());
        while (client_in.hasNextLine()) {
          if (client.isInputShutdown())
            break;
          try {
            buffer.put(client_in.nextLine());
          } catch (InterruptedException e) {
            Thread.currentThread().interrupt();
          }
        }
        client_in.close();
        if (!client.isClosed()) client.close();
        clients.remove(client);
      } catch (IOException exn) {
        chatter.quit("%s: %s%n", server.ident(), exn);
      }
    }
  }

  // static class queue_mgr implements Runnable {
  // public void run() {
  // String line = new String();
  // for (;;) {
  // if (buffer.isEmpty()) continue;
  // try {
  // line = buffer.take();
  // } catch (InterruptedException e) {
  // continue;
  // }
  //
  // }
  // }
  // }

  static class sender implements Runnable {
    public void run() {
      for (;;) {
        String message = buffer.poll();
        if (message == null)
          continue;
        Iterator<Socket> itor = clients.keySet().iterator();
        while (itor.hasNext()) {
          try {
            Socket client_itor = itor.next();
            if (client_itor.isOutputShutdown()) {
              client_itor.close();
              clients.remove(client_itor);
              continue;
            }
            PrintWriter client_out = new PrintWriter(
                client_itor.getOutputStream());
            client_out.println(message);
            client_out.flush();
          } catch (IOException exn) {
            chatter.quit("%s: %s%n", server.ident(), exn);
          }
        }
      }
    }
  }
}
